﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace erettsegi0_Triatlon
{
    class erettsegi0_Triatlon
    {
        struct sadatok
        {
            public string név;
            public TimeSpan úszás;
            public TimeSpan kerékpár;
            public TimeSpan futás;
            public TimeSpan össz { get { return úszás + kerékpár + futás; } }
        }

        static void Main()
        {
            #region 1. feladat: Az adatok beolvasásá, tömb feltöltése
            Console.WriteLine("\n1. Feladat: Adatok olvasása, adatszerkezet feltöltése");

            int adb = 0;
            List<sadatok> adatok = new List<sadatok>();
            using (StreamReader sr = new StreamReader("Triatlon.be"))
            {
                adb=int.Parse(sr.ReadLine()); //adatok darabszáma szama
                for (int i = 0; i < adb; i++)
                {
                    sadatok adat = new sadatok()
                    { 
                        név= sr.ReadLine(),
                        úszás = TimeSpan.FromSeconds(double.Parse(sr.ReadLine())),
                        kerékpár = TimeSpan.FromSeconds(double.Parse(sr.ReadLine())),
                        futás = TimeSpan.FromSeconds(double.Parse(sr.ReadLine())),
                    };
                    adatok.Add(adat);
                }
            }
            #endregion

            #region 2. feladat: Dobogós versenyzők
            Console.WriteLine("2. Feladat: Dobogós versenyzők");
            var dobogós = from i in adatok
                          orderby i.össz
                          select i;
            for (int i = 0; i < 3; i++) Console.WriteLine(" {0}. {1}",i+1,dobogós.ElementAt(i).név);
            #endregion

            #region 3. feladat: Átlagsebességek
            Console.WriteLine("3. Feladat: Átlagsebességek:");
            
            Console.WriteLine("Úszás: {0} Km/h",1.5/dobogós.First().úszás.TotalHours);
            Console.WriteLine("Kerépározás: {0} Km/h", 40 / dobogós.First().kerékpár.TotalHours);
            Console.WriteLine("Futás: {0} Km/h", 10 / dobogós.First().futás.TotalHours);
            #endregion

            #region 4. 5. 6. feladatok: Triatlon.ki
            Console.WriteLine("4. 5. 6. Feladatok: Triatlon.ki");
            using (StreamWriter sw = new StreamWriter("Triatlon.ki"))
            {
                foreach (var i in dobogós) sw.WriteLine(i.név + ' ' + i.össz.ToString());
            }
            #endregion

            #region 7. feladat: Triatlon.ki
            Console.WriteLine("7. Feladat: Reszer.ki");

            var wúszás = (from i in adatok orderby i.úszás select i).First();
            var wkerékpár = (from i in adatok orderby i.kerékpár select i).First();
            var wfutás = (from i in adatok orderby i.futás select i).First();

            using (StreamWriter sw = new StreamWriter("Reszer.ki"))
            {
                sw.WriteLine(wúszás.név + ' ' + wúszás.úszás.ToString());
                sw.WriteLine(wkerékpár.név + ' ' + wkerékpár.kerékpár.ToString());
                sw.WriteLine(wfutás.név + ' ' + wfutás.futás.ToString());
            }
            #endregion

            Console.ReadKey();
        }
    }
}
